SystemOrganization addCategory: #ConnectorsText!

NCTextMorph subclass: #NCDisplayTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsText'!

!NCDisplayTextMorph class methodsFor: 'scripting' stamp: 'nk 8/31/2004 13:46'!
additionsToViewerCategoryText

	^ #(
text (
(slot focused	'True if I am displaying a cursor and listening for keystrokes' Boolean	readWrite Player getTextFocus  Player setTextFocus:)
)) ! !

!NCDisplayTextMorph class methodsFor: 'scripting' stamp: 'nk 8/31/2004 11:53'!
authoringPrototype
	"NCDisplayTextMorph authoringPrototype openInHand"
	^super boldAuthoringPrototype
		wrapFlag: false;
		refreshParagraph;
		yourself
! !

!NCDisplayTextMorph class methodsFor: 'class initialization' stamp: 'nk 12/28/2004 14:57'!
initialize
	"NCDisplayTextMorph initialize"
	ScriptingSystem addCustomEventFor: self named: #acceptedTextContents help: 'when text is accepted into a text morph by hitting Enter or losing focus' targetMorphClass: self.
! !

!NCDisplayTextMorph class methodsFor: 'parts bin' stamp: 'nk 9/2/2004 17:20'!
supplementaryPartsDescriptions
	^{
	(DescriptionForPartsBin
		formalName: 'Text2'
		categoryList: #('Connectors')
		documentation: 'A raw piece of text (with a context menu) which you can edit into anything you want'
		globalReceiverSymbol: #NCDisplayTextMorph
		nativitySelector: #authoringPrototype) sampleImageForm: (self authoringPrototype imageFormDepth: 32); yourself.
	}
! !

!NCDisplayTextMorph class methodsFor: 'scripting' stamp: 'nk 9/2/2004 07:57'!
wrappedAuthoringPrototype
	"NCDisplayTextMorph wrappedAuthoringPrototype openInHand"
	^self authoringPrototype
		wrapFlag: false;
		refreshParagraph;
		wrapFlag: true;
		yourself
! !

!NCDisplayTextMorph methodsFor: 'event handling' stamp: 'nk 8/30/2004 05:58'!
addBasicMenuItemsTo: aCustomMenu event: evt 
	aCustomMenu add: 'grab' target: evt hand selector: #attachMorph: argument: self.
	owner ifNotNil: [
		aCustomMenu add: 'delete' target: self selector: #dismissViaHalo;
		add: 'resize' target: self selector: #resizeMorph: argument: evt;
		addLine.
		self addLayoutMenuItems: aCustomMenu hand: evt hand.
		aCustomMenu addLine.
		self addToggleItemsToHaloMenu: aCustomMenu.
		aCustomMenu addLine].

	(Smalltalk includesKey: #NCMakerButton) ifTrue: [
		aCustomMenu add: 'make button' action: #makeButton: ].
	aCustomMenu		 addLine.
	aCustomMenu
		add: 'properties...'
		target: self
		selector: #openAPropertySheet! !

!NCDisplayTextMorph methodsFor: 'accessing' stamp: 'nk 8/27/2004 17:08'!
addTextMenuItemsTo: aCustomMenu event: evt

	aCustomMenu addLine.
	aCustomMenu add: 'choose font...' translated action: #promptForFont.

	^aCustomMenu! !

!NCDisplayTextMorph methodsFor: 'event handling' stamp: 'nk 8/30/2004 05:55'!
addYellowButtonMenuItemsTo: aCustomMenu event: evt 
	super addYellowButtonMenuItemsTo: aCustomMenu event: evt.
	self addBasicMenuItemsTo: aCustomMenu event: evt.
	self addCustomMenuItems: aCustomMenu hand: evt hand.
	self addTextMenuItemsTo: aCustomMenu event: evt! !

!NCDisplayTextMorph methodsFor: 'accessing' stamp: 'nk 8/27/2004 17:12'!
beAllFont: aFont
	self editor selection isEmptyOrNil ifTrue: [ self editor selectAll ].
	textStyle := TextStyle fontArray: (Array with: aFont).
	self releaseCachedState; changed! !

!NCDisplayTextMorph methodsFor: 'accessing' stamp: 'nk 10/13/2003 17:09'!
contentsAsIs: stringOrText
	"Accept new text contents with line breaks only as in the text.
	Fit my width and height to the result."
	wrapFlag := false.
	self newContents: stringOrText! !

!NCDisplayTextMorph methodsFor: 'initialization' stamp: 'nk 10/13/2003 17:09'!
fontName: fontname pointSize: size
	super fontName: fontname pointSize: size.
	self updateFromParagraph.! !

!NCDisplayTextMorph methodsFor: 'initialization' stamp: 'nk 10/13/2003 17:09'!
fontName: fontname size: size
	super fontName: fontname size: size.
	self updateFromParagraph.! !

!NCDisplayTextMorph methodsFor: 'event handling' stamp: 'nk 8/22/2004 17:32'!
handleInteraction: interActionBlock fromEvent: evt
	"Overridden to pass along a model to the editor for, eg, link resolution, doits, etc"
	self trackFocusFromEvent: evt.
	self hasFocus ifFalse: [ ^self ].

	self editor model: self.  "For evaluateSelection, etc"
	^ super handleInteraction: interActionBlock fromEvent: evt! !

!NCDisplayTextMorph methodsFor: 'event handling' stamp: 'nk 8/27/2004 11:01'!
hasYellowButtonMenu	
	^true! !

!NCDisplayTextMorph methodsFor: 'initialization' stamp: 'nk 10/13/2003 17:09'!
initialize
	super initialize.
	wrapFlag := false.
	self margins: 6@0.
	self autoFit: true! !

!NCDisplayTextMorph methodsFor: 'event handling' stamp: 'nk 8/22/2004 17:14'!
keyStroke: evt 
	"Copied from StringMorphEditor"

	"This is hugely inefficient, but it seems to work, and it's unlikely it will ever need
	to be any more efficient -- it's only intended to edit single-line strings."

	| newSel |

	super keyStroke: evt.
	ActiveHand keyboardFocus == self ifFalse: [ self releaseEditor. ^self ].
	newSel := self editor selectionInterval.	"restore editor state"
	self refreshParagraph.
	self editor selectFrom: newSel first to: newSel last.
! !

!NCDisplayTextMorph methodsFor: 'event handling' stamp: 'nk 8/31/2004 12:07'!
mouseDown: evt 
	evt yellowButtonPressed ifTrue: [ ^ self yellowButtonActivity: evt shiftPressed ].
	^super mouseDown: evt! !

!NCDisplayTextMorph methodsFor: 'accessing' stamp: 'nk 8/27/2004 17:10'!
promptForFont
	self editor selection isEmptyOrNil ifTrue: [ self editor selectAll ].
	TextStyle promptForFont: 'Choose font:' andSendTo: self withSelector: #beAllFont:! !

!NCDisplayTextMorph methodsFor: 'event handling' stamp: 'nk 10/13/2003 17:09'!
refreshParagraph
	| priorEditor |
	priorEditor := editor.	"Save editor state"
	self releaseParagraph.	"Release paragraph so it will grow with selection."
	self paragraph.	"Re-instantiate to set new bounds"
	priorEditor ifNotNil: [ self installEditorToReplace: priorEditor	]. "restore editor state"
! !

!NCDisplayTextMorph methodsFor: 'event handling' stamp: 'nk 8/22/2004 16:38'!
updateFromParagraph

	super updateFromParagraph.
	self hasFocus ifFalse: [ ^self ].

	(self isAutoFit and: [ wrapFlag not ])
		ifTrue: [ self refreshParagraph ].
	self editor.
! !

NCDisplayTextMorph subclass: #NCGrabbableDisplayTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConnectorsText'!

!NCGrabbableDisplayTextMorph class methodsFor: 'parts bin' stamp: 'nk 9/2/2004 17:17'!
authoringPrototype
	"
	NCGrabbableDisplayTextMorph authoringPrototype openInHand
	"
	^super authoringPrototype
		fontName: 'BitstreamVeraSans' pointSize: 36;
		contentsAsIs: 'Title';
		yourself! !

!NCGrabbableDisplayTextMorph class methodsFor: 'parts bin' stamp: 'nk 8/31/2004 11:45'!
newBodyText
	^self authoringPrototype
		wrapFlag: true;
		yourself
! !

!NCGrabbableDisplayTextMorph class methodsFor: 'parts bin' stamp: 'nk 9/2/2004 15:40'!
supplementaryPartsDescriptions
	^{
	DescriptionForPartsBin
		formalName: 'Title'
		categoryList: #('Connectors')
		documentation: 'Text that you can grab and move around (click to edit)'
		globalReceiverSymbol: #NCGrabbableDisplayTextMorph
		nativitySelector: #authoringPrototype.
	}
! !

!NCGrabbableDisplayTextMorph methodsFor: 'event handling' stamp: 'nk 8/22/2004 17:34'!
click: evt
	self trackFocusFromEvent: evt.
	evt wasHandled: true.! !

!NCGrabbableDisplayTextMorph methodsFor: 'event handling' stamp: 'nk 8/29/2004 21:18'!
doubleClick: evt 
	evt hand newKeyboardFocus: self.
	^self click: evt! !

!NCGrabbableDisplayTextMorph methodsFor: 'event handling' stamp: 'nk 3/10/2004 08:05'!
doubleClickTimeout: evt 

	evt hand lastEvent anyButtonPressed ifFalse: [ ^super mouseDown: evt ]! !

!NCGrabbableDisplayTextMorph methodsFor: 'event handling' stamp: 'nk 8/22/2004 17:39'!
focusBoundsFor: anEvent
	| rect |
	rect := anEvent hand autoFocusRectangleBoundsFor: self.
	^rect quickMerge: (self outerBounds outsetBy: 40).
! !

!NCGrabbableDisplayTextMorph methodsFor: 'dispatching' stamp: 'nk 10/23/2003 19:58'!
gesture: aCRGesture
	aCRGesture target: self gestureHandler.
	super gesture: aCRGesture! !

!NCGrabbableDisplayTextMorph methodsFor: 'dispatching' stamp: 'nk 10/19/2003 19:09'!
gestureHandler
	^ActiveHand keyboardFocus == self
		ifTrue: [ self ]
		ifFalse: [ self rootInPasteUp ifNil: [ self ]].
! !

!NCGrabbableDisplayTextMorph methodsFor: 'event handling' stamp: 'nk 8/23/2004 11:26'!
handleListenEvent: anEvent 
	| rect |
	self trackFocusFromEvent: anEvent.
	self hasFocus
		ifTrue: [(anEvent isMouseDown
					and: [self hasHalo not])
				ifTrue: [rect := self focusBoundsFor: anEvent.
					(rect containsPoint: anEvent position)
						ifFalse: [anEvent hand releaseKeyboardFocus: self]]].
! !

!NCGrabbableDisplayTextMorph methodsFor: 'editing' stamp: 'nk 8/22/2004 17:29'!
keyboardFocusChange: aBoolean
	aBoolean
		ifTrue: [ ActiveHand addMouseListener: self ]
		ifFalse: [ ActiveHand removeMouseListener: self ].

	^super keyboardFocusChange: aBoolean.
! !

!NCGrabbableDisplayTextMorph methodsFor: 'editing' stamp: 'nk 8/27/2004 16:50'!
mouseDown: evt 
	self trackFocusFromEvent: evt.

	(evt hand keyboardFocus == self)
		ifTrue: [^ super mouseDown: evt].

	evt yellowButtonPressed ifTrue: [ ^ self yellowButtonActivity: evt shiftPressed ].

	evt hand waitForClicksOrDrag: self event: evt.
	evt wasHandled: true! !

!NCGrabbableDisplayTextMorph methodsFor: 'initialization' stamp: 'nk 10/23/2003 23:40'!
outOfWorld: aWorld
	aWorld currentHand removeMouseListener: self.
	super outOfWorld: aWorld! !

!NCGrabbableDisplayTextMorph methodsFor: 'event handling' stamp: 'nk 10/18/2003 15:22'!
startDrag: evt 
	| root |
	root := self rootInPasteUp.
	evt hand releaseKeyboardFocus: self.
	root eventHandler
		ifNotNil: [(root eventHandler handlesClickOrDrag: evt)
				ifTrue: [^ root eventHandler startDrag: evt fromMorph: root]].
	evt hand grabMorph: root! !

!NCGrabbableDisplayTextMorph methodsFor: 'dispatching' stamp: 'nk 10/23/2003 23:53'!
wantsAutoFocusStartEvent: aMouseButtonEvent
	aMouseButtonEvent hand keyboardFocus == self
		ifFalse: [ self releaseCachedState. ^false ].
	^super wantsAutoFocusStartEvent: aMouseButtonEvent! !

!Player methodsFor: '*connectorstext-slot getters/setters' stamp: 'nk 8/31/2004 13:46'!
getTextFocus
	^self getValueFromCostume: #hasFocus! !

!Player methodsFor: '*connectorstext-slot getters/setters' stamp: 'nk 8/31/2004 13:56'!
setTextFocus: aBoolean 
	self costume isTextMorph
		ifFalse: [^ self].
	(aBoolean == self costume hasFocus) ifTrue: [ ^self ].
	aBoolean
		ifTrue: [
			ActiveHand newKeyboardFocus: self costume.
			self costume selectFrom: (self costume cursor) to: (self costume cursor - 1).
			]
		ifFalse: [
			ActiveHand releaseKeyboardFocus: self costume].
	self costume changed! !
NCDisplayTextMorph initialize!
